'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DatePicker = require('material-ui/DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _TimePicker = require('material-ui/TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DateTimePicker = function (_React$Component) {
  (0, _inherits3.default)(DateTimePicker, _React$Component);

  function DateTimePicker() {
    (0, _classCallCheck3.default)(this, DateTimePicker);
    return (0, _possibleConstructorReturn3.default)(this, (DateTimePicker.__proto__ || (0, _getPrototypeOf2.default)(DateTimePicker)).apply(this, arguments));
  }

  (0, _createClass3.default)(DateTimePicker, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var value = this.getValue(this.props.value);

      this.state = {
        date: value,
        time: value,
        value: value
      };

      this.handleChange = this.handleChange.bind(this);
      this.getDateFromDateTime = this.getDateFromDateTime.bind(this);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var value = this.getValue(nextProps.value);

      if (value === undefined) {
        this.setState({
          time: nextProps.value,
          date: nextProps.value,
          value: nextProps.value
        });

        return;
      }

      if (Date.parse(nextProps.value) !== Date.parse(this.props.value)) {
        var date = new Date(nextProps.value);
        var time = new Date(nextProps.value);
        var _value = this.getDateFromDateTime({ date: date, time: time });
        this.setState({ date: date, time: time, value: _value });
      }
    }
  }, {
    key: 'getValue',
    value: function getValue(value) {
      if (isNaN(Date.parse(value))) {
        return;
      }

      return new Date(value);
    }
  }, {
    key: 'getDateFromDateTime',
    value: function getDateFromDateTime(_ref) {
      var _ref$date = _ref.date,
          date = _ref$date === undefined ? this.state.date : _ref$date,
          _ref$time = _ref.time,
          time = _ref$time === undefined ? this.state.time : _ref$time;

      var dateArr = [];

      if (!isNaN(Date.parse(date))) {
        dateArr[0] = date.getFullYear();
        dateArr[1] = date.getMonth();
        dateArr[2] = date.getDate();
      }

      if (!isNaN(Date.parse(time))) {
        dateArr[3] = time.getHours();
        dateArr[4] = time.getMinutes();
      }

      return new (Function.prototype.bind.apply(Date, [null].concat(dateArr)))();
    }
  }, {
    key: 'handleChange',
    value: function handleChange(_ref2) {
      var _ref2$date = _ref2.date,
          date = _ref2$date === undefined ? undefined : _ref2$date,
          _ref2$time = _ref2.time,
          time = _ref2$time === undefined ? undefined : _ref2$time;

      var value = this.getDateFromDateTime({ date: date, time: time });
      this.setState({ value: value });
      if (typeof this.props.onChange === 'function') {
        this.props.onChange(undefined, value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          onChange = _props.onChange,
          props = (0, _objectWithoutProperties3.default)(_props, ['onChange']); // eslint-disable-line no-unused-vars

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_DatePicker2.default, (0, _extends3.default)({
          id: 'datefield'
        }, props, {
          value: this.state.date,
          formatDate: function formatDate(date) {
            return date.toLocaleDateString() + ' ' + (_this2.state.time && _this2.state.time.toLocaleTimeString() || '');
          },
          onChange: function onChange(_, date) {
            _this2.setState({ date: date });
            _this2.handleChange({ date: date });
            _this2.timepicker.openDialog();
          }
        })),
        _react2.default.createElement(_TimePicker2.default, {
          id: 'timefield',
          ref: function ref(elem) {
            return _this2.timepicker = elem;
          },
          style: { display: 'none' },
          onChange: function onChange(_, time) {
            time.setSeconds(0, 0);
            _this2.setState({ time: time });
            _this2.handleChange({ time: time });
          },
          value: this.state.time
        })
      );
    }
  }]);
  return DateTimePicker;
}(_react2.default.Component);

DateTimePicker.propTypes = {
  value: _propTypes2.default.object,
  onChange: _propTypes2.default.func
};

exports.default = DateTimePicker;